{% load static %}

<head>
  <title>{{items_title}}</title>

  {% include 'sub_templates/base.html' %}
  {{'caja_gris/lectura.scss'|css_compiler|safe}}

  <script type="text/javascript">
    function action_test_selected(data){
      window.location.href = 'http://'+window.location.host+'/{{project_id}}/caja_gris/lectura/'+data;
    }
    
    $( document ).ready( function (){
      // database left-nav-bar
      $('#database_data').appendTo('.left-nav-bar .top-side .container')
      $("#select-database").val('{{test.database}}')

      {% if test_conection == 'ok' %}
        $('.left-nav-bar .top-side .container .status .connection-status').attr('data-original-title', 'La conexión a la base de datos funciona correctamente');
      {% else %}
        $('.left-nav-bar .top-side .container .status .connection-status').attr('data-original-title', 'La conexión no ha sido probada');
      {% endif %}
      $('.left-nav-bar .top-side .container .status .connection-status').tooltip('enable')
      // database left-nav-bar

      $('.new-environment-variable input').on('change', (e)=>{
        $(e.currentTarget.parentElement).children('.plus').addClass('edited')
      })

      {% for validation in validations.comparison_validations %}
        append_validation('comparison-validations', 
          '{{validation.id}}',
          '{{validation.logic_type}}', 
          '{{validation.variable}}', 
          '{{validation.description}}', 
          {
            {% if validation.data.python_code %} 'python_code': {{validation.data.python_code|safe}}, {% endif %}
            'true_color': '{{validation.data.true_color}}',
            'true_comment': '{{validation.data.true_comment}}',
            'false_color': '{{validation.data.false_color}}',
            'false_comment': '{{validation.data.false_comment}}'
          });
      {% endfor %}

      {% for validation in validations.sequential_validations %}
        append_validation('sequential-validations', 
          '{{validation.id}}',
          '{{validation.logic_type}}', 
          '{{validation.variable}}', 
          '{{validation.description}}', 
          {
            {% if validation.data.python_code %} 'python_code': {{validation.data.python_code|safe}}, {% endif %}
            'true_color': '{{validation.data.true_color}}',
            'true_comment': '{{validation.data.true_comment}}',
            'false_color': '{{validation.data.false_color}}',
            'false_comment': '{{validation.data.false_comment}}'
          });
      {% endfor %}

      start_unsaved_changes_messages();
    })

    function new_data(data_type){
      let variable = $('.new-environment-variable .var')[0].value;
      let value = $('.new-environment-variable .val')[0].value;
      let description = ''

      let existant_headers_variables = [];

      existant_headers = $('#existant-environment-variables .var');
      for (var i = 0; i < existant_headers.length; i++) {
        existant_headers_variables.push(existant_headers[i].value);
      }

      append_data = '<div class="existant-environment-variable form-data"><input class="col-5 form-control var" type="text" placeholder="Agregar una variable" value="'+variable+'" maxlength="40"><input class="col-6 form-control val" type="text" placeholder="Valor" value="'+value+'" maxlength="40"><div class="times"><a onclick="delete_data(this);">{{"times-solid.svg"|svgColor:"var(--danger)"|safe}}</a></div></div>'
      if (variable != '' && value != '' && !existant_headers_variables.includes(variable)){
        $('#existant-environment-variables').append(append_data);
        $('.new-environment-variable .var')[0].value = '';
        $('.new-environment-variable .val')[0].value = '';
        $('.new-environment-variable .plus').removeAttr('data-original-title');
      }
      else{
        if (variable == ''){
          $('.new-environment-variable .var')[0].focus();
          $('.new-environment-variable .plus').attr('data-original-title', 'No se puede agregar una variable vacía');
          $('.new-environment-variable .plus').tooltip('show');
        }
        else if (value == ''){
          $('.new-environment-variable .val')[0].focus();
          $('.new-environment-variable .plus').attr('data-original-title', 'No se puede agregar una variable con valor vacío');
          $('.new-environment-variable .plus').tooltip('show');
        }
        else if (existant_headers_variables.includes(variable)){
          $('.new-environment-variable .var')[0].focus();
          $('.new-environment-variable .plus').attr('data-original-title', 'La variable especificada ya existe');
          $('.new-environment-variable .plus').tooltip('show');
        }
      }
    }

    function test_database_connection(){
      $('.left-nav-bar .top-side .container .status .connection-status').html('<div class="spinner-border text-info" role="status">\
          <span class="sr-only">Loading...</span>\
        </div>');

      // aqui se hace la consulta a la bd (usando los datos de la base de datos del proyecto que ya fue testeada)
      $.ajax({
        url: '/readings/test_database',
        type: 'POST',
        data: {
          'test_id': '{{test_id}}',
          'database_type': $('#select-database').val(),
          'service': $('#service').val(),
          'username': $('#db_username').val(),
          'password': $('#db_password').val(),
          'host': $('#host').val(),
          'port': $('#port').val(),
        },
        success: function(result){
          push_alert('Base de datos guardada correctamente', 'alert-success');
          localStorage.clear();

          $('.left-nav-bar .top-side .container .status .connection-status').html('{{"check-circle-solid.svg"|svgColor:"var(--teal)"|safe}}');
          $('.left-nav-bar .top-side .container .status .connection-status').attr('data-original-title', 'La conexión a la base de datos funciona correctamente<br>(se han guardado los datos para esta prueba)');
          $('.left-nav-bar .top-side .container .status .connection-status').tooltip('show')
          setTimeout(()=>{
            $('.left-nav-bar .top-side .container .status .connection-status').tooltip('hide')
          }, 4000)
          $('.sql-query .query-header .test-sql-btn').removeAttr('disabled')
        },
        error: function(result){
          $('.left-nav-bar .top-side .container .status .connection-status').html('{{"times-circle-solid.svg"|svgColor:"var(--danger)"|safe}}');
          $('.left-nav-bar .top-side .container .status .connection-status').attr('data-original-title', 'No hay conexión a la base de datos');
          $('.left-nav-bar .top-side .container .status .connection-status').tooltip('show')
          setTimeout(()=>{
            $('.left-nav-bar .top-side .container .status .connection-status').tooltip('hide')
          }, 4000);
        }
      });
    }

    function test_sql_query(){
      $('#test-sql-query .modal-header .modal-title').text("Realizando consulta SQL");
      $('#test-sql-query .modal-body .container').html('<div class="spinner-container centerX">\
          <div class="spinner-border" role="status">\
            <span class="sr-only">Loading...</span>\
          </div>\
        </div>');

      $.ajax({
        url: '/readings/test_sql',
        type: 'POST',
        data: {
          'test_id': '{{test_id}}',
          'query': $('#sql-textarea').val(),
        },
        success: function(result){
          response = ''
          $('#test-sql-query .modal-header .modal-title').text("Variables asociadas a la consulta");
          // $('#test-sql-query .modal-body .container').html(result['variables'].join(', '));
          for (var table in result){
            response = response + '<b>' + table + '</b><br>'
            response = response + (result[table]).join(', ') + '<br><br>'
          }
          $('#test-sql-query .modal-body .container').html(response);

          $('.test-sql-btn').removeAttr('onclick');
          $('.test-sql-btn').text('Ver Variables');

          $('select.variable option[value=""]').text('Por favor, actualiza la pagina para actualizar las variables');

          push_alert('Consulta SQL ejecutada correctamente', 'alert-success');
        },
        error: function(result){
          $('#test-sql-query .modal-header .modal-title').text("Error");
          if (result.responseText.includes('La query debe comenzar con SELECT')){
            $('#test-sql-query .modal-body .container').html('Error: La consulta debe comenzar con SELECT');
          }
          else{
            console.log(result);
            $('#test-sql-query .modal-body .container').html('Ocurrio un error inesperado, por favor, verifica que la consulta esté bien escrita');
          }
        }
      });
    }

    function toggle_sql_button(){
      $('.test-sql-btn').attr('onclick',"test_sql_query();");
      $('.test-sql-btn').text('Probar Consulta');
    }

    function modal_add_validation(validation_type){
      let inputs = $('#new-'+validation_type).children().children().children('.container').children().children('.col-sm-9').children();
      let variable = inputs[0].value;
      let description = inputs[1].value;

      if(variable == ''){
        alert('Debes seleccionar una variable objetivo para crear una validación');
      }
      else{
        append_validation(validation_type+'s', 0, 'Codigo Python', variable, description);

        $(inputs[0]).val($(inputs[0]).children()[0].value);
        $(inputs[1]).val('');
      }
    }

    function append_validation(validation_type, id, logic_type, variable, description, data){
      if (!['comparison-validations', 'sequential-validations'].includes(validation_type)){return 'Error';}
      if (!['Codigo Python', 'Ayudante Logico'].includes(logic_type)){return 'Error';}

      let base = $('#base_validation').clone();
      
      base.removeAttr("id");

      var variables_data = []
      if (validation_type == 'comparison-validations'){
        base.children('.data').children('.conditions-and-actions').children('.logic-code').children('textarea').attr('placeholder',["Escribir aqui codigo en lenguaje python, en que se retorne la comparacion principal de la variable seleccionada. Ej:", "", 'if @order.order_id==1:', '\treturn @customer.customer_name==\'George\''].join('\n'));
        variables_data = [
          {% for variable in variables.variables %}
          { id:1, name:'@{{variable}}', 'type':'variable' },
          {% endfor %}
        ];
      }
      else if (validation_type == 'sequential-validations'){
        base.children('.data').children('.conditions-and-actions').children('.logic-code').children('textarea').attr('placeholder',["Escribir aqui codigo en lenguaje python, en que se retorne la comparacion principal de la variable seleccionada. Ej:", "", 'if @order.order_type==1:', '\treturn @order.ballance == (@order.ballance_anterior - 1000)'].join('\n'));
        variables_data = [
          {% for variable in variables.variables %}
          { id:1, name:'@{{variable}}', 'type':'variable' },
          { id:2, name:'@{{variable}}_anterior', 'type':'variable' },
          {% endfor %}
        ];
      }

      // if (logic_type == 'Codigo Python'){
      base.children('.data').children('.conditions-and-actions').children('.logic-helper').remove();

      base.children('.data').children('.conditions-and-actions').children('.logic-code').children('textarea').mentionsInput({
        onDataRequest:function (mode, query, callback) {
          var data = variables_data

          data = _.filter(data, function(item) { return item.name.toLowerCase().indexOf(query.toLowerCase()) > -1 });

          callback.call(this, data);
        }
      });
      if (typeof(data)=='object' && 'python_code' in data){
        base.children('.data').children('.conditions-and-actions').children('.logic-code').children().children('textarea').val(data['python_code'].join('\n'));
      }
      // }
      // else{
      //   base.children('.data').children('.conditions-and-actions').children('.logic-code').remove();
      //   // aqui va algo mucho mas complejo, considerando cada elemento del arbol de flujo
      // }

      if (id != 0){
        base.attr('validation-id', id);
      }
      base.children('.data').children('.headers').children('.logic-type').text(logic_type);
      base.children('.data').children('.headers').children('.variable').children('span').text(variable);
      base.children('.data').children('.headers').children('.description').children('span').text(description);

      if (typeof(data)=='object' && 'true_color' in data){
        base.children('.data').children('.conditions-and-actions').children('.mark-result').children('nav').children('.validate-ok').children('.marks').children('.color').children('.value').val(data['true_color']);
      }

      base.children('.data').children('.conditions-and-actions').children('.mark-result').children('nav').children('.validate-ok').children('.marks').children('.comment').children('.value').mentionsInput({
        onDataRequest:function (mode, query, callback) {
          var data = variables_data

          data = _.filter(data, function(item) { return item.name.toLowerCase().indexOf(query.toLowerCase()) > -1 });

          callback.call(this, data);
        }
      });
      if (typeof(data)=='object' && 'python_code' in data){
        base.children('.data').children('.conditions-and-actions').children('.mark-result').children('nav').children('.validate-ok').children('.marks').children('.comment').children().children('.value').val(getValue(data, 'true_comment'));
      }

      if (typeof(data)=='object' && 'false_color' in data){
        base.children('.data').children('.conditions-and-actions').children('.mark-result').children('nav').children('.validate-false').children('.marks').children('.color').children('.value').val(data['false_color']);
      }

      base.children('.data').children('.conditions-and-actions').children('.mark-result').children('nav').children('.validate-false').children('.marks').children('.comment').children('.value').mentionsInput({
        onDataRequest:function (mode, query, callback) {
          var data = variables_data

          data = _.filter(data, function(item) { return item.name.toLowerCase().indexOf(query.toLowerCase()) > -1 });

          callback.call(this, data);
        }
      });
      if (typeof(data)=='object' && 'python_code' in data){
        base.children('.data').children('.conditions-and-actions').children('.mark-result').children('nav').children('.validate-false').children('.marks').children('.comment').children().children('.value').val(getValue(data, 'false_comment'));
      }


      $('.'+validation_type).append(base);

      base.children('.data').children('.conditions-and-actions').children('.logic-code').children().children('textarea').keydown(function(e) {
        if(e.keyCode === 9) { // tab was pressed
          // get caret position/selection
          var start = this.selectionStart;
              end = this.selectionEnd;

          var $this = $(this);

          // set textarea value to: text before caret + tab + text after caret
          $this.val($this.val().substring(0, start)
                      + "\t"
                      + $this.val().substring(end));

          // put caret at right position again
          this.selectionStart = this.selectionEnd = start + 1;

          // prevent the focus lose
          return false;
        }
      });
      base.show();
    }

    function save_environment_variables(){
      let variables = {}
      $('#existant-environment-variables .existant-environment-variable').each((i,elem)=>{
        inputs = $(elem).children('input');
        variables[inputs[0].value] = inputs[1].value;
      });

      $.ajax({
        url: '/{{project_id}}/environment/update',
        type: 'POST',
        data: {
          'clean_variables': true,
          'variable': variables,
        },
        success: function(result){
          $('#environment-variables-modal').modal('hide');
          push_alert('Variables de entorno modificadas correctamente', 'alert-success');
        },
        error: function(result){
          console.log(result);
          alert('Ocurrio un error inesperado');
        }
      });
    }


    function save_validation_ajax(elem, validation_type){
      let header_data = $(elem).children('.headers').children()
      let variable = header_data[1].children[0].textContent
      let description = header_data[2].children[0].textContent

      let conditions_data = $(elem).children('.conditions-and-actions').children()
      let code = conditions_data.children('.mentions-input-box').children('textarea').val()

      let marks = $(conditions_data[1]).children()
      let ok_marks = marks.children('.validate-ok').children()
      let false_marks = marks.children('.validate-false').children()

      let ok_color = ok_marks.children('.color').children('select').val()
      let ok_comment = ok_marks.children('.comment').children().children('textarea').val()
      let false_color = false_marks.children('.color').children('select').val()
      let false_comment = false_marks.children('.comment').children().children('textarea').val()

      let id = '0'
      if (elem.parentNode.hasAttribute('validation-id')){
        id = elem.parentNode.getAttribute('validation-id');
      }

      $.ajax({
        url: '/readings/validation/create',
        type: 'POST',
        data: {
          'id': id,
          'validation_type': validation_type,
          'variable': variable,
          'description': description,
          'code': code,
          'ok_color': ok_color,
          'ok_comment': ok_comment,
          'false_color': false_color,
          'false_comment': false_comment,
          'test_id': {{test_id}}
        },
        // success: function(result){
        //   // $('#environment-variables-modal').modal('hide');
        // },
        error: function(result){
          console.log(result);
          push_alert('Ocurrio un error inesperado al guardar la validacion: "'+description+'"', 'alert-danger');
          // alert('Ocurrio un error inesperado al guardar la validacion: "'+description+'"');
        }
      });
    }

    function save_validations(){
      // test_sql_query(); //para guardarla nuevamente
      $.ajax({
        url: '/readings/test_sql',
        type: 'POST',
        data: {
          'test_id': '{{test_id}}',
          'query': $('#sql-textarea').val(),
        },
        success: function(result){
          // eliminar de la base de datos las validaciones que no aparezcan en la lista de ids
          ids = []
          $('.validation[validation-id]').each((i,elem)=>{
            ids.push(elem.getAttribute('validation-id'))
          })

          $.ajax({
            url: '/readings/validation/delete_remaining',
            type: 'POST',
            data: {
              'ids': ids,
              'test_id': {{test_id}}
            },
            success: function(result){
              // por cada variable se hace un ajax para guardarla
              // validaciones de comparasiones
              $('.comparison-validations .validation .data').each((i, elem)=>{
                save_validation_ajax(elem, 'comparison');
              });

              // validaciones de secuencias
              $('.sequential-validations .validation .data').each((i, elem)=>{
                save_validation_ajax(elem, 'sequential');
              });

              localStorage.clear();
              window.location.reload();
            },
            error: function(result){
              console.log(result);
              alert('Ocurrio un error inesperado');
              return;
            }
          });

        },
        error: function(result){
          if (result.responseText.includes('La query debe comenzar con SELECT')){
            alert('Error: La consulta debe comenzar con SELECT');
          }
          else{
            console.log(result);
            alert('Ocurrio un error inesperado, por favor, verifica que la consulta esté bien escrita');
          }
        }
      });
    }

    // function execute_validations(){
    //   // save_validations();
    //   // aqui falta un mensaje de advertencia cuando no se han guardado los datos

    //   $.ajax({
    //     url: '/readings/execute/{{test_id}}',
    //     type: 'POST',
    //     success: function(result){
    //         // descargar el archivo
    //         a.href = url;
    //         a.download = 'myfile.pdf';
    //         document.body.append(a);
    //         a.click();
    //         a.remove();
    //         window.URL.revokeObjectURL(url);
    //       window.location.reload();
    //     },
    //     error: function(result){
    //       console.log(result);
    //       alert('Ocurrio un error inesperado');
    //     }
    //   });
    // }

  </script>
</head>

<body>
  {% include 'sub_templates/left_nav_bar.html' %}
  {% include 'sub_templates/read_validation.html' %}

  <div class="back-button">
    <a href="/{{project_id}}/caja_gris">{{'arrow-left-solid.svg'|svgColor:'var(--secondary)'|safe}}</a>
  </div>
  <div>
    {% if test.status == 'built' %}
    <div class="test-status built" data-toggle="tooltip" onclick="toogle_test_status(this, '{{test_type}}', '{{test_id}}');" title="Marcar prueba como 'En construcción'"> Construida </div>
    {% else %}
    <div class="test-status in-construction" data-toggle="tooltip" onclick="toogle_test_status(this, '{{test_type}}', '{{test_id}}');" title="Marcar prueba como 'Construida'"> En construcción </div>
    {% endif %}
  </div>

  <div class="content">
    <div class="read-container">
      <div class="header">
        <div class="title">
          {{title}}
        </div>
        <button class="environment-variables btn btn-info" data-toggle="modal" data-target="#environment-variables-modal"> Variables de entorno<br>del proyecto</button>
      </div>

      <div class="sql-query">
        <div class="query-header">
          <div class="title centerX">
            Consulta SQL
          </div>

          {% if variables %}
          <button class="btn btn-outline-info test-sql-btn" data-toggle="modal" data-target="#test-sql-query">Ver Variables</button>
          {% else %}
          <button class="btn btn-outline-info test-sql-btn" data-toggle="modal" data-target="#test-sql-query" onclick="test_sql_query();" {% if test_conection != 'ok' %} disabled {% endif %}>Probar Consulta</button><!-- aqui hacer una accion -->
          {% endif %}

        </div>
        <textarea class="form-control" id="sql-textarea" onchange="toggle_sql_button()" placeholder="Consulta del tipo SQL con la que se obtengan todos los datos requeridos para ser comparados.
NOTA: se recomienda utilizar todos los JOIN's que sean necesarios para obtener todos los datos en una unica consulta

Ej: SELECT Orders.OrderID, Customers.CustomerName, Orders.OrderDate
FROM Orders
INNER JOIN Customers
ON Orders.CustomerID=Customers.CustomerID;">{{test.sql}}</textarea>
      </div>

      <div class="validations">
        <div class="title">Validaciones</div>
        <div class="comparison">
          <div class="sub-title">
            <span>Comparación</span>
            <div class="helper" data-toggle="tooltip" data-html="true" 
              title="Sentencias logicas para comparar variables en una misma fila (Para validar que los datos de una transaccion sean consistentes)">
              {{'question-circle-regular.svg'|svgColor:'var(--secondary)'|safe}}
            </div>
          </div>
          <div class="comparison-validations">
          </div>
          <button class="btn btn-info add-validation" data-toggle="modal" data-target="#new-comparison-validation">Añadir validación</button>
        </div>
        <div class="sequential">
          <div class="sub-title">
            <span>Secuencial</span>
            <div class="helper" data-toggle="tooltip" data-html="true" 
              title="Sentencias logicas par comparar una variable especifica con la fila anterior (luego de la realizacion de una transacción)<br>NOTA: Para referenciar una variable de la fila anterior, usar:<br>'@[nombre_variable]_anterior'">
              {{'question-circle-regular.svg'|svgColor:'var(--secondary)'|safe}}
            </div>
          </div>
          <div class="sequential-validations">
          </div>
          <button class="btn btn-info add-validation" data-toggle="modal" data-target="#new-sequential-validation">Añadir validación</button>
        </div>
      </div>

      <div class="save-execute">
        <button id="save_test" class="btn btn-outline-info save" onclick="save_validations();"> Guardar </button>
        <form class="mb-0" action='/readings/execute/{{test_id}}' method="POST">
          <!-- <button class="btn btn-info execute" onclick="execute_validations();"> Ejecutar </button> -->
          {% csrf_token %}
          <button id="execute_test" type="submit" class="btn btn-info execute"> Ejecutar </button>
        </form>
      </div>
    </div>
  </div>

  <!-- Modal test sql query -->
  <div class="modal fade" id="test-sql-query" tabindex="-1" role="dialog" aria-labelledby="new-test-title" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="new-test-title">
            Variables asociadas a la consulta
          </h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <div class="container">
            {% if variables %}
            {{variables.variables|show_variables|safe}}
            {% endif %}
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-primary" data-dismiss="modal">Cerrar</button>
        </div>
      </div>
    </div>
  </div>

  <!-- Modal agregar validacion de comparacion -->
  <div class="modal fade" id="new-comparison-validation" tabindex="-1" role="dialog" aria-labelledby="new-comparison-validation-title" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="new-comparison-validation-title">Agregar validación comparativa</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="container">
          <div class="row align-items-center form-group">
            <label class="col-sm-3 col-form-label">Variable Objetivo</label>
            <div class="col-sm-9">
              <select class="custom-select variable">
                {% if not variables %}
                <option value="">No hay variables asociadas a esta prueba</option>
                {% endif %}
                {{ variables.variables|show_variables_options|safe }}
              </select>
            </div>
          </div>
          <div class="row align-items-center form-group">
            <label class="col-sm-3 col-form-label">Descripción</label>
            <div class="col-sm-9">
              <input type="text" name="name" class="form-control" placeholder="Ej: Verificacion de nombre del comprador">
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
          <button type="submit" class="btn btn-primary" data-dismiss="modal" onclick="modal_add_validation('comparison-validation');">Añadir</button>
        </div>
      </div>
    </div>
  </div>

  <!-- Modal agregar validación de sequential -->
  <div class="modal fade" id="new-sequential-validation" tabindex="-1" role="dialog" aria-labelledby="new-sequential-validation-title" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="new-sequential-validation-title">Agregar validación secuencial</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="container">
          <div class="row align-items-center form-group">
            <label class="col-sm-3 col-form-label">Variable Objetivo</label>
            <div class="col-sm-9">
              <select class="custom-select variable">
                {% if not variables %}
                <option value="">No hay variables asociadas a esta prueba</option>
                {% endif %}
                {{ variables.variables|show_variables_options|safe }}
              </select>
            </div>
          </div>
          <div class="row align-items-center form-group">
            <label class="col-sm-3 col-form-label">Descripción</label>
            <div class="col-sm-9">
              <input type="text" name="name" class="form-control" placeholder="Ej: Verificacion de descuento de sueldo" maxlength="400">
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
          <button type="button" class="btn btn-primary" data-dismiss="modal" onclick="modal_add_validation('sequential-validation');">Añadir</button>
        </div>
      </div>
    </div>
  </div>

  <!-- Modal variables de entorno -->
  <div class="modal fade" id="environment-variables-modal" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered" role="document">
      <div class="modal-content">
        <div class="modal-header align-items-center">
          <h5 class="modal-title" id="new-test-title">Modificar variables de entorno</h5>
          <div class="helper" style="width: 1.5rem; margin-left: 1rem;" data-toggle="tooltip" data-html="true" 
            title="Las variables de entorno son utilizadas para facilitar el manejo de datos cuando hay informacion que constantemente puede cambiar.<br>Para utilizarlas, se pueden utilizar en cualquier input, escribiendo el nombre de la variable de entorno encerrada en llaves y corchetes <br> ej: {[nombre_variable_entorno]} <br> lo que traducirá el nombre de la variable en el valor que ésta posea">
            {{'question-circle-regular.svg'|svgColor:'var(--secondary)'|safe}}
          </div>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>

        </div>
        <div class="modal-body" id="environment-variables-form">
          <div class="container">

            <div class="environment-variables">
              <div class="head-row">
                <label class="col-5">Variable de entorno</label>
                <label class="col-6">Valor</label>
              </div>
              <!-- Variables existentes -->
              <div id="existant-environment-variables">
                {% for environment_variable in existant_environment_variables %}
                <div class="existant-environment-variable form-data">
                  <input class="col-5 form-control var" type="text" placeholder="Agregar un dominio" value="{{environment_variable.var}}" maxlength="40">
                  <input class="col-6 form-control val" type="text" placeholder="Valor" value="{{environment_variable.val}}" maxlength="40">
                  <div class="times">
                    <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
                  </div>
                </div>
                {% endfor %}
              </div>
              <!-- Agregar nueva variable -->
              <div class="new-environment-variable form-data">
                <input class="col-5 form-control var" type="text" placeholder="Agregar una variable" maxlength="40">
                <input class="col-6 form-control val" type="text" placeholder="Valor" maxlength="40">
                <div class="plus" data-toggle="tooltip" data-placement="top">
                  <a onclick="new_data('environment_variable');">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
                </div>
              </div>
            </div>

          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancelar</button>
          <button type="button" class="btn btn-primary" onclick="save_environment_variables();">Guardar</button>
        </div>
      </div>
    </div>
  </div>

      
  <!-- Database data -->
  <div id="database_data" >
    <div class="title">Base de Datos</div>
    <form class="form">
      <select class="custom-select centerX" id="select-database">
        <option value="">Seleccionar base de datos</option>
        {% for db in all_databases %}
        <option value="{{db.value}}">{{db.name}}</option>
        {% endfor %}
      </select>
      <div class="service parameter">
        <label class="col-4 col-form-label">SID</label>
        <input id="service" type="text" class="col-8 form-control" placeholder="SID de la BD" value="{{test.service}}">
      </div>
      <div class="db_user parameter">
        <label class="col-4 col-form-label">Usuario</label>
        <input id="db_username" type="text" class="col-8 form-control" placeholder="Nombre de usuario" autocomplete="off" value="{{test.username}}">
      </div>
      <div class="db_password parameter">
        <label class="col-4 col-form-label">Contraseña</label>
        <input style="display:none" type="password" name="autocompleteoffpatch"/>
        <input id="db_password" type="password" class="col-8 form-control" placeholder="Contraseña del usuario" autocomplete="user-password" value="{{test.password}}">
      </div>
      <div class="host parameter">
        <label class="col-4 col-form-label">Host</label>
        <input id="host" type="text" class="col-8 form-control" placeholder="ej: localhost" value="{{test.host}}">
      </div>
      <div class="port parameter">
        <label class="col-4 col-form-label">Puerto</label>
        <input id="port" type="text" class="col-8 form-control" placeholder="Puerto por defecto" value="{{test.port}}">
      </div>
    </form>
    <div class="status">
      <div class="connection-status" data-toggle="tooltip" data-html="true" data-placement="bottom">
        {% if test_conection == 'ok' %}
          {{"check-circle-solid.svg"|svgColor:"var(--teal)"|safe}}
        {% else %}
          {{"times-circle-solid.svg"|svgColor:"var(--orange)"|safe}}
        {% endif %}
      </div>
      <button class="btn btn-outline-info test centerX" onclick="test_database_connection();">Probar Conexión</button>
    </div>
  </div>
</body>